/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ch.randelshofer.media.quicktime;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.util.Random;

/**
 * Main.
 *
 * @author Werner Randelshofer
 * @version 1.0 2008-00-15 Created.
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            test(new File("quicktimedemo-jpg.mov"), QuickTimeOutputStream.VideoFormat.JPG, 1f);
            test(new File("quicktimedemo-png.mov"), QuickTimeOutputStream.VideoFormat.PNG, 1f);
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private static void test(File file, QuickTimeOutputStream.VideoFormat format, float quality) throws IOException {
        QuickTimeOutputStream out = null;
        Graphics2D g = null;
        try {
            out = new QuickTimeOutputStream(file, format);
            out.setVideoCompressionQuality(quality);
            out.setTimeScale(30); // 30 fps

            Random r = new Random();
            BufferedImage img = new BufferedImage(320, 160, BufferedImage.TYPE_INT_RGB);
            g = img.createGraphics();
            g.setBackground(Color.WHITE);
            g.clearRect(0, 0, img.getWidth(), img.getHeight());

            for (int i = 0; i < 100; i++) {
                g.setColor(new Color(r.nextInt()));
                g.fillRect(r.nextInt(img.getWidth() - 30), r.nextInt(img.getHeight() - 30), 30, 30);
                out.writeFrame(img, 1);
            }

        } finally {
            if (g != null) {
                g.dispose();
            }
            if (out != null) {
                out.close();
            }
        }
    }
}
